scmAntiSpam = {}

SCM_ANTISPAM_HISTORY = 5
SCM_ANTISPAM_BLOCKSPAMMERS = nil

local tokens = {
	"29games",
	"365ig",
	"agamego",
	"buyw0wgame",
	"gamenoble",
	"gmwork",
	"gmw0rk",
	"goldwithyou",
	"gold4guild",
	"hugold",
	"igs36",
	"igm365",
	"igamebuy",
	"igdollarc",
	"igtuc",
	"itembay",
	"itemratec",
	"helpugame",
	"mmoinn",
	"ogchannel",
	"ogmarket",
	"gs365",
	"ogs4u",
	"okstar2008",
	"peons4",
	"p3ons4",
	"player123",
	"playsupplier",
	"ssegames",
	"speedpanda",
	"wow7gold",
	"wowcoming",
	"woweuropecn",
	"wowforever",
	"wowfreebuy",
	"wowgoldsky",
	"wowpanning",
	"wowpfs",
	"wowspa",
	"wowstar2008",
	"wowsupplier",
	"wowseller",
	"zlywy",
	"gmauthorization",
	"woweuropegold",
	"1225game",
	"plsalec",
}
local spammers = {}

local spam = {}
local orig = nil

local function handler(...)
	if type(arg1) == "string" and type(arg2) == "string" then
		if SCM_ANTISPAM_BLOCKSPAMMERS and spammers[arg2] then return end
		local x = arg1..arg2
		if spam[x] then return end
		table.insert(spam, x)
		spam[x] = 1
		if #spam > SCM_ANTISPAM_HISTORY then
			spam[table.remove(spam, 1)] = nil
		end

		if SCM_ANTISPAM_BLOCKSPAMMERS then
			local spamString = arg1:gsub("%p", ""):trim():lower()
			for i, v in ipairs(tokens) do
				if spamString:find(v) then
					spammers[arg2] = true
					return
				end
			end
		end
	end

	return orig(...)
end

function scmAntiSpam:Enable()
	if not orig then
		orig = ChatFrame_MessageEventHandler
	end
	ChatFrame_MessageEventHandler = handler
end

function scmAntiSpam:Disable()
	if not orig then return end
	ChatFrame_MessageEventHandler = orig
end

scmAntiSpam:Enable()

